#pragma semicolon 1

#include <sourcemod>
#include <sdktools_sound>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [No Step Sound]",
	author	= "AlliedModders/wS",
	version = "1.0.3"
};

#define ITEM_NAME "no_step_sound"

new Handle:sv_footsteps;
new bool:g_bAccess[MAXPLAYERS + 1];

public OnPluginStart()
{
	if ((sv_footsteps = FindConVar("sv_footsteps")) == INVALID_HANDLE)
		SetFailState("sv_footsteps not found");

	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_TOGGLE))
		SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);

	HookConVarChange(sv_footsteps, cvar_changed);
	if (GetConVarInt(sv_footsteps) != 1) SetConVarInt(sv_footsteps, 1);

	for (new i = 1; i <= MaxClients; i++) { if (IsClientInGame(i)) OnClientPutInServer(i); }
	AddNormalSoundHook(NormalSoundHook_CallBack);
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_bAccess[client])
	{
		IntToString(1, ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	if (g_bAccess[client]) return VGA_AlreadyEnabled;
	SetStatus(client, true);
	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	SetStatus(client, false);
}

stock SetStatus(client, bool:enabled)
{
	g_bAccess[client] = enabled;
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, enabled);
}

///////////////////////////////////////////////////////////////////////////////////

public cvar_changed(Handle:hCvar, const String:OldValue[],		const String:NewValue[]) { if (StringToInt(NewValue) != 1) SetConVarInt(hCvar, 1); }
public OnClientPutInServer(client) { if (!IsFakeClient(client))	SendConVarValue(client, sv_footsteps, "0"); }
public OnClientDisconnect(client)								g_bAccess[client] = false;

public Action:NormalSoundHook_CallBack(clients[64], &numClients, String:sample[PLATFORM_MAX_PATH], &entity, &channel, &Float:volume, &level, &pitch, &flags)
{
	if (entity > 0 && entity <= MaxClients && StrContains(sample, "footsteps", false) > -1)
	{
		if (g_bAccess[entity]) return Plugin_Stop;
		numClients = 0;
		for (new i = 1; i <= MaxClients; i++) { if (IsClientInGame(i) && !IsFakeClient(i)) clients[numClients++] = i; }
		EmitSound(clients, numClients, sample, entity);
	}
	return Plugin_Continue;
}